"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const get_added_keys_from_objects_1 = require("./common/get-added-keys-from-objects");
const get_removed_keys_from_objects_1 = require("./common/get-removed-keys-from-objects");
const create_difference_1 = require("./create-difference");
const findAddedMethodDifferences = (sourceOperations, destinationOperations) => {
    return get_added_keys_from_objects_1.getAddedKeysFromObjects(sourceOperations, destinationOperations)
        .map((addedMethod) => {
        const addedDestinationOperation = destinationOperations[addedMethod];
        return create_difference_1.createDifference({
            action: 'add',
            destinationObject: addedDestinationOperation.originalValue,
            propertyName: 'method'
        });
    });
};
const findRemovedMethodDifferences = (sourceOperations, destinationOperations) => {
    return get_removed_keys_from_objects_1.getRemovedKeysFromObjects(sourceOperations, destinationOperations)
        .map((removedMethod) => {
        const removedSourceOperation = sourceOperations[removedMethod];
        return create_difference_1.createDifference({
            action: 'remove',
            propertyName: 'method',
            sourceObject: removedSourceOperation.originalValue
        });
    });
};
exports.findDifferencesInOperations = (sourceOperations, destinationOperations) => {
    return [
        ...findAddedMethodDifferences(sourceOperations, destinationOperations),
        ...findRemovedMethodDifferences(sourceOperations, destinationOperations)
    ];
};
